config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.frr.new
config etc/logrotate.d/frr.new
config etc/frr/daemons.new
config etc/frr/vtysh.conf.new

if [ -x /usr/bin/install-info ]; then
  chroot . /usr/bin/install-info --info-dir=/usr/info /usr/info/frr-info.gz 2> /dev/null
  chroot . /usr/bin/install-info --info-dir=/usr/info /usr/info/frr-info-1.gz 2> /dev/null
  chroot . /usr/bin/install-info --info-dir=/usr/info /usr/info/frr-info-2.gz 2> /dev/null
fi
( cd usr/lib64 ; rm -rf libfrr.so )
( cd usr/lib64 ; ln -sf libfrr.so.0.0.0 libfrr.so )
( cd usr/lib64 ; rm -rf libfrr.so.0 )
( cd usr/lib64 ; ln -sf libfrr.so.0.0.0 libfrr.so.0 )
( cd usr/lib64 ; rm -rf libfrr_pb.so )
( cd usr/lib64 ; ln -sf libfrr_pb.so.0.0.0 libfrr_pb.so )
( cd usr/lib64 ; rm -rf libfrr_pb.so.0 )
( cd usr/lib64 ; ln -sf libfrr_pb.so.0.0.0 libfrr_pb.so.0 )
( cd usr/lib64 ; rm -rf libfrrcares.so )
( cd usr/lib64 ; ln -sf libfrrcares.so.0.0.0 libfrrcares.so )
( cd usr/lib64 ; rm -rf libfrrcares.so.0 )
( cd usr/lib64 ; ln -sf libfrrcares.so.0.0.0 libfrrcares.so.0 )
( cd usr/lib64 ; rm -rf libfrrfpm_pb.so )
( cd usr/lib64 ; ln -sf libfrrfpm_pb.so.0.0.0 libfrrfpm_pb.so )
( cd usr/lib64 ; rm -rf libfrrfpm_pb.so.0 )
( cd usr/lib64 ; ln -sf libfrrfpm_pb.so.0.0.0 libfrrfpm_pb.so.0 )
( cd usr/lib64 ; rm -rf libfrrospfapiclient.so )
( cd usr/lib64 ; ln -sf libfrrospfapiclient.so.0.0.0 libfrrospfapiclient.so )
( cd usr/lib64 ; rm -rf libfrrospfapiclient.so.0 )
( cd usr/lib64 ; ln -sf libfrrospfapiclient.so.0.0.0 libfrrospfapiclient.so.0 )
( cd usr/lib64 ; rm -rf libfrrsnmp.so )
( cd usr/lib64 ; ln -sf libfrrsnmp.so.0.0.0 libfrrsnmp.so )
( cd usr/lib64 ; rm -rf libfrrsnmp.so.0 )
( cd usr/lib64 ; ln -sf libfrrsnmp.so.0.0.0 libfrrsnmp.so.0 )
( cd usr/lib64 ; rm -rf libmgmt_be_nb.so )
( cd usr/lib64 ; ln -sf libmgmt_be_nb.so.0.0.0 libmgmt_be_nb.so )
( cd usr/lib64 ; rm -rf libmgmt_be_nb.so.0 )
( cd usr/lib64 ; ln -sf libmgmt_be_nb.so.0.0.0 libmgmt_be_nb.so.0 )
